# -*- coding: utf-8 -*-

'''
Copyright (C) 2014                                                     

This program is free software: you can redistribute it and/or modify   
it under the terms of the GNU General Public License as published by   
the Free Software Foundation, either version 3 of the License, or      
(at your option) any later version.                                    

This program is distributed in the hope that it will be useful,        
but WITHOUT ANY WARRANTY; without even the implied warranty of         
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          
GNU General Public License for more details.                           

You should have received a copy of the GNU General Public License      
along with this program. If not, see <http://www.gnu.org/licenses/>  
'''                                                                           

import urllib,urllib2,re,os,base64
import xbmcplugin,xbmcgui,xbmcaddon

addon = xbmcaddon.Addon(id='plugin.video.itv.sport')
profile = addon.getAddonInfo('profile')
home = addon.getAddonInfo('path')
dataPatch = xbmc.translatePath(os.path.join(home, 'resources'))
logos = xbmc.translatePath(os.path.join(dataPatch, 'logos\\'))
fanart = xbmc.translatePath(os.path.join(home, 'fanart.jpg'))
icon = xbmc.translatePath(os.path.join(home, 'icon.png'))
sys.path.append(os.path.join(home,'resources','lib'));from BeautifulSoup import BeautifulSoup;import urlfetch

def main():
    content = makeRequest(isport)
    match = re.compile('<channel>\s*<name>(.+?)</name>\s*<thumb>(.+?)</thumb>').findall(content)
    for channel_name, thumb in match:
        addDir( channel_name, isport, 4, thumb, '', isFolder=True)
    addDir( '8bongda', bongda8, 2, logos + '8bongda.png', page=1, isFolder=True)
    xbmc.executebuiltin('Container.SetViewMode(500)')	

def medialist(url,page=1):
    content = makeRequest(url)
    match = re.compile('<a href="(.+?)" rel="bookmark" title="(.+?)" class="img-shadow"><img.+?src="//(.+?)" class=".+?" alt=".+?"/></a>').findall(content)[:10]
    for href, title, thumb in match:
	    addDir( title.replace('Link sopcast trận ',''), href, 3, 'http://' + thumb, '', isFolder=True)
    if len(match) == 10:
        page = page+1
        next_page = url.split('page/')[0] + 'page/' + str(page)
        addDir( '[COLOR red]Next >>>[COLOR green] ' + 'trang ' + str(page) + '[/COLOR]', next_page, 2, logos + 'NEXT.png', page = page, isFolder=True)
    xbmc.executebuiltin('Container.SetViewMode(51)')

def episodes(url):
	content = makeRequest(url)
	items = re.compile('href="((sop|acestream):.*?)" target="_blank">(.*?)<\/a>(.*?)<br').findall(content)
	for item in items:
		if 'sop://' in item[0]: name = '[COLOR blue]Sopcast[/COLOR]: %s' % item[3]
		if 'acestream://' in item[0]: name = '[COLOR violet]acestream[/COLOR]: %s ' % item[2].replace('&gt;&gt;','')
		addDir( name, item[0], 200, '', '', isFolder=False)
	xbmc.executebuiltin('Container.SetViewMode(51)')

def itv_channel(name,url):
    name = name	
    content = makeRequest(url)
    match = re.compile('<channel>\s*<name>' + name + '</name>((?s).+?)</channel>').findall(content)
    for items in match:
        item = re.compile('#EXTINF.+,(.+)\s(.+?)\s').findall(items)	
        for name, link in item:
	        addDir( name, link, 100, iconimage, '', isFolder=False)
    xbmc.executebuiltin('Container.SetViewMode(51)')
	
def resolveUrl(url):
    mediaUrl = url
    item = xbmcgui.ListItem(path=mediaUrl)		
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
    return

def play_p2p(url,name):
    if addon.getSetting('default_player') == 'p2p-streams':
        if 'sop://' in url:
            mediaUrl = 'plugin://plugin.video.p2p-streams/?mode=2&url=%s&name=%s' % (url,urllib.quote_plus(name)) 
        else:
            mediaUrl = 'plugin://plugin.video.p2p-streams/?mode=1&url=%s&name=%s' % (url,urllib.quote_plus(name))
    else:
        if 'sop://' in url:
            mediaUrl = 'plugin://program.plexus/?mode=2&url=%s&name=%s' % (url,urllib.quote_plus(name)) 
        else:
            mediaUrl = 'plugin://program.plexus/?mode=1&url=%s&name=%s' % (url,urllib.quote_plus(name))
    item = xbmcgui.ListItem(path=mediaUrl)
    xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, item)
    return
	
def makeRequest(url, headers=None):
    if headers is None:
        headers = {'User-agent' : 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36',
                 'Referer' : 'http://www.google.com'}
    try:
        req = urllib2.Request(url,headers=headers)
        f = urllib2.urlopen(req)
        body=f.read()
        return body
    except:
        pass 
  
def d ( k , e ) :
    data = [ ]
    e = base64.urlsafe_b64decode ( e )
    for i in range ( len ( e ) ) :
        ch1 = k [ i % len ( k ) ]
        ch2 = chr ( ( 256 + ord ( e [ i ] ) - ord ( ch1 ) ) % 256 )
        data.append ( ch2 )
    return "".join ( data )

def addDir(name,url,mode,iconimage,page=0,isFolder=False):
    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&page="+str(page)
    ok=True
    liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    liz.setInfo( type="Video", infoLabels={ "Title": name } )
    if not isFolder:
        liz.setProperty('IsPlayable', 'true')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=isFolder)
    return ok
	  	
def get_params():
    param=[]
    paramstring=sys.argv[2]
    if len(paramstring)>=2:
        params=sys.argv[2]
        cleanedparams=params.replace('?','')
        if (params[len(params)-1]=='/'):
            params=params[0:len(params)-2]
        pairsofparams=cleanedparams.split('&')
        param={}
        for i in range(len(pairsofparams)):
            splitparams={}
            splitparams=pairsofparams[i].split('=')
            if (len(splitparams))==2:
                param[splitparams[0]]=splitparams[1]
    return param

isport = d ( "spo", "2-Tj46qeoujR4NOd3OTl49zk5p7d2OSexsTBuLG8otnj6bDi49_h557j6-Q=" )
bongda8 = d ( "bd8", "ytis0p5nkduv2ZJwxNOmyciZkMenz5Owx9FlxNOmyZGcw5Gs1Nmbj9it28mmkdCh0M9l1dOoxcWr1pM=" )
params=get_params()
url=None
name=None
mode=None
iconimage=None
page=0

try:url=urllib.unquote_plus(params["url"])
except:pass
try:name=urllib.unquote_plus(params["name"])
except:pass
try:mode=int(params["mode"])
except:pass
try:iconimage=urllib.unquote_plus(params["iconimage"])
except:pass
try:page=int(urllib.unquote_plus(params["page"]))
except:pass

if mode==None or url==None or len(url)<1:main()
elif mode==1:search()
elif mode==2:medialist(url,page)
elif mode==3:episodes(url)
elif mode==4:itv_channel(name,url)

elif mode==100:
    dialogWait = xbmcgui.DialogProgress()
    dialogWait.create('***ITV PLUS***', 'Đang tải. Vui lòng chờ trong giây lát...')
    resolveUrl(url)
    dialogWait.close()
    del dialogWait
	
elif mode==200:
    dialogWait = xbmcgui.DialogProgress()
    dialogWait.create('***ITV PLUS***', 'Đang tải. Vui lòng chờ trong giây lát...')
    play_p2p(url,name)
    dialogWait.close()
    del dialogWait
  
xbmcplugin.endOfDirectory(int(sys.argv[1]))